#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <time.h>
#include  <sys/time.h>
#include  <sys/stat.h>

#define  LOG_PATH_LEN  1024
#define  STRING_LEN  128


int logging(char *str, int send_recv)
{
	FILE *fp;
	char date_str[STRING_LEN];
	char log_file_path[LOG_PATH_LEN];
	struct timeval tp;
	struct timezone tzp;
	struct tm ltime;
	char split_line[STRING_LEN];


	if(getenv("XIP_LOG_FILE") == NULL){
		return 0;
	}
	
	strcpy(log_file_path, getenv("XIP_LOG_FILE"));
	
	fp = fopen(log_file_path, "a");
	if(fp == NULL){
		fprintf(stderr, "%s file can't open.\n", log_file_path);
		perror("");
		exit(-1);
	}

	
	gettimeofday(&tp, &tzp);
	memmove(&ltime, localtime((time_t *)&tp), sizeof(struct tm));
	sprintf(date_str, "%04dǯ %02d %02d  %02d %02dʬ %02d",
			ltime.tm_year + 1900, ltime.tm_mon + 1, ltime.tm_mday,
			ltime.tm_hour, ltime.tm_min, ltime.tm_sec);

	if(send_recv == 0){  /*  receive  */
		if(getenv("XIP_RECV_LINE") == NULL){
			strcpy(split_line, "--------------------------------------------------");
		}
		else{
			strcpy(split_line, getenv("XIP_RECV_LINE"));
		}
		fprintf(fp, "%s\n", split_line);
		fprintf(fp, "%s\n", date_str);
		fprintf(fp, "%s\n", str);
		fprintf(fp, "%s\n", split_line);
	}
	else{  /*  send  */
		if(getenv("XIP_SEND_LINE") == NULL){
			strcpy(split_line, "==================================================");
		}
		else{
			strcpy(split_line, getenv("XIP_SEND_LINE"));
		}
		fprintf(fp, "%s\n", split_line);
		fprintf(fp, "%s\n", date_str);
		fprintf(fp, "%s\n", str);
		fprintf(fp, "%s\n", split_line);
	}		

	fclose(fp);

	chmod(log_file_path, S_IRUSR | S_IWUSR);

	return 0;
}
